-- safelua.lua
-- runs a .slua file in a minimal (totally tight) sandbox
-- This is a little outdated and not so flexible anymore.
-- For a good alternative, please see lib_runflex.lua and the corresponding
-- examples.
--
-- Usage: safelua.lua [-v] yourscript.slua
--
-- Examples:
--   safelua.lua examples\helloworld.slua
--   safelua.lua examples\example-bytecode
--
-- Version: Safe Lua 0.2 (http://safelua.sf.net)
-- by Stefan Reich (www.friedensrevolution.de)
-- Contact: stefan.reich.maker.of.eye@gmail.com
-- This code is public domain!

require "lib_safelua"

function parseArguments()
  filename = nil
  for i=1, #arg do
    if arg[i] == '-v' then
      verbose = true
    elseif not filename then
      filename = arg[i]
    end
  end
end

parseArguments()

if filename then
  sandbox = makeSandbox()
  
  status, result = runScript(filename, sandbox)
  if verbose or not status then
    if not (status and result == nil) then
      io.stderr:write((status and "Script returned: " or "Script error: ")..tostring(result).."\n")
    end
  end
else
  io.stderr:write("Usage: safelua.lua [-v] yourscript.slua\n")
end

